package org.nosqlite4j.core;

import java.io.IOException;

import org.json.JSONException;
import org.json.JSONObject;

public abstract class DBManager {
	private String metaContent;
	private Configuration config = new Configuration();

	public String read(String table) throws IOException, JSONException,
			NullPointerException {
		String values = null;
		MetaStore meta = new MetaStore();
		meta.setTable(table);
		if (meta.checkTable()) {
			metaContent = meta.metaReader();
			JSONObject metadata = new JSONObject(metaContent);
			values = metadata.get(table).toString();
		} else {
			System.err.println("Table Does not exist");
		}
		return values;

	}

	public String getDBloc() {
		return config.getDBLoc();
	}

	public String getDelimiter() {
		return config.getDelimter();
	}

	public int getfullScanFlushSize() {
		return config.getfullScanFlushSize();
	}

	public String getInternal_Delimiter() {
		return config.getinternalDelimiter();
	}

	public String getColumn_Oriented() {
		return config.getcolumnOriented();
	}

	public int getReadSize() {
		return config.getreadSize();
	}

}
