package org.nosqlite4j.core;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class DBStats {
	private long DBSize;
	private String Report = "";
	private long Table_Size;
	private ArrayList<String> Qualifiers;
	private ArrayList<Long> Qualifier_size;
	private MetaStore meta = new MetaStore();
	private Configuration config = new Configuration();

	public DBStats() throws IOException, JSONException {
		long total_size = 0;
		JSONArray jarr = new JSONArray();
		ArrayList<String> tablenames = meta.list();
		for (int i = 0; i < tablenames.size(); i++) {
			JSONObject tab = new JSONObject();
			File file = new File(config.getDBLoc() + "/" + tablenames.get(i));
			Table_Size = 0;
			Qualifier_size = new ArrayList<Long>();
			Qualifiers = new ArrayList<String>();

			if (file.isDirectory()) {
				recur(file);
			}

			tab.put("TableName", tablenames.get(i));
			tab.put("TotalSize", Table_Size);
			for (int j = 0; j < Qualifiers.size(); j++) {
				tab.put(Qualifiers.get(j), Qualifier_size.get(j));
			}
			jarr.put(tab);

		}
		DBSize = total_size;
		Report = jarr.toString();
	}

	public long getDBSize() {
		return DBSize;
	}

	public String getReport() {
		return Report;
	}

	private void recur(File file) {
		String[] filelist = file.list();
		for (int i = 0; i < filelist.length; i++) {
			File temp = new File(file.getAbsoluteFile() + "/" + filelist[i]);
			if (temp.isDirectory()) {
				recur(temp);
			} else {
				Table_Size = Table_Size
						+ new File(file.getAbsoluteFile() + "/" + filelist[i])
								.length();
				Qualifiers.add(filelist[i]);
				Qualifier_size.add(new File(file.getAbsoluteFile() + "/"
						+ filelist[i]).length());

			}
		}
	}

}
