package org.nosqlite4j.core;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

public class MetaStore {
	private String Table;
	private ArrayList<String> ColumnFamily;
	private JSONObject StoreThis;
	Configuration config = new Configuration();
	private String DBloc = config.getDBLoc();
	private String MetaStoreName = config.getmetaStore();

	public MetaStore() throws IOException {
		File file = new File(DBloc + "/" + "metastore");
		file.createNewFile();
	}

	public String getTable() {
		return Table;
	}

	public void setTable(String table) {
		Table = table;
	}

	public ArrayList<String> getColumnFamily() {
		return ColumnFamily;
	}

	public void setColumnFamily(ArrayList<String> columnFamily) {
		ColumnFamily = columnFamily;
	}

	public void deleteEntry() {
		try {

			String metaContent = this.metaReader();

			if (metaContent.equals("")) {
				StoreThis = new JSONObject();
			} else {
				StoreThis = new JSONObject(metaContent);
			}
			StoreThis.remove(Table);

			FileWriter fstream = new FileWriter(DBloc + "/" + MetaStoreName);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(StoreThis.toString());
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public void alterEntry(String tablename) {
		try {

			String metaContent = this.metaReader();

			if (metaContent.equals("")) {
				System.err.println("Table does not exist");

			} else {
				StoreThis = new JSONObject(metaContent);
			}
			JSONArray JArr = new JSONArray(StoreThis.get(Table).toString());
			StoreThis.remove(Table);
			StoreThis.put(tablename, JArr);

			FileWriter fstream = new FileWriter(DBloc + "/" + MetaStoreName);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(StoreThis.toString());
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public void update() {
		try {

			String metaContent = this.metaReader();

			if (metaContent.equals("")) {
				StoreThis = new JSONObject();

			} else {
				StoreThis = new JSONObject(metaContent);
			}
			JSONArray JArr = new JSONArray(ColumnFamily);

			StoreThis.put(Table, JArr);
			FileWriter fstream = new FileWriter(DBloc + "/" + MetaStoreName);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(StoreThis.toString());
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public boolean checkTable() throws JSONException, IOException {
		boolean check;

		String metaContent = this.metaReader();
		if (metaContent.equals("")) {
			check = false;
		} else {
			JSONObject tempTab = new JSONObject(metaContent);

			if (tempTab.has(Table)) {
				check = true;
				return check;
			} else {
				check = false;
			}
		}

		return check;

	}

	public ArrayList<String> list() throws IOException, JSONException {
		ArrayList<String> tables = new ArrayList<String>();
		String metaContent = this.metaReader();
		if (metaContent.equals("")) {
			return tables;
		} else {
			JSONObject object = (JSONObject) new JSONTokener(metaContent)
					.nextValue();
			@SuppressWarnings("unchecked")
			Iterator<String> yourKeys = object.keys();
			do {
				tables.add(yourKeys.next());
			} while (yourKeys.hasNext());
		}

		return tables;

	}

	public boolean editColfam(String tablename, String cf1, String cf2)
			throws IOException, JSONException {
		String metaContent = this.metaReader();
		boolean check = false;
		JSONObject obj = new JSONObject(metaContent);
		JSONArray jarr = obj.getJSONArray(tablename);
		JSONArray jarrTemp = new JSONArray();
		int lessCount = jarr.length();
		while (lessCount != 0) {
			if (jarr.get(lessCount - 1).toString().equals(cf1)) {
				jarrTemp.put(lessCount - 1, cf2);
				check = true;
			} else {
				jarrTemp.put(lessCount - 1, jarr.get(lessCount - 1).toString());
			}
			lessCount--;
		}
		obj.put(tablename, jarrTemp);
		System.out.println(obj);
		FileWriter fstream = new FileWriter(DBloc + "/" + MetaStoreName);
		BufferedWriter out = new BufferedWriter(fstream);
		out.write(obj.toString());
		out.close();
		return check;

	}

	public String metaReader() throws IOException {
		String metaContent = "";
		FileInputStream fistream = new FileInputStream(DBloc + "/"
				+ MetaStoreName);
		DataInputStream in = new DataInputStream(fistream);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		String strLine;
		while ((strLine = br.readLine()) != null) {
			metaContent = metaContent + strLine;
		}
		in.close();
		return metaContent;
	}

}
