package org.nosqlite4j.core.ddl;

import java.io.File;
import java.io.IOException;

import org.json.JSONException;
import org.nosqlite4j.core.Configuration;
import org.nosqlite4j.core.MetaStore;

public class AlterTable {
	String TableName;
	String newTableName;
	String ColumnFamily;
	String ChangedToColumnFamily;

	public AlterTable(String tablename, String newTable) {
		TableName = tablename;
		newTableName = newTable;
	}

	public AlterTable() {

	}

	public AlterTable(String tablename, String Colfam1, String Colfam2) {
		TableName = tablename;
		ColumnFamily = Colfam1;
		ChangedToColumnFamily = Colfam2;
	}

	public void alterColumnFamily() throws Exception {
		long startTime = System.currentTimeMillis();

		if (ColumnFamily == null || ChangedToColumnFamily == null) {
			System.err.println("Add the the column family to be altered");
		} else {
			MetaStore meta = new MetaStore();
			meta.setTable(TableName);
			if (meta.checkTable()) {
				if (meta.editColfam(TableName, ColumnFamily,
						ChangedToColumnFamily)) {
					Configuration config = new Configuration();
					File dir = new File(config.getDBLoc() + "/" + TableName
							+ "/" + ColumnFamily + "/");
					File newDir = new File(config.getDBLoc() + "/" + TableName
							+ "/" + ChangedToColumnFamily + "/");
					dir.renameTo(newDir);
					System.out.println("Table Altered");
				}

			} else {
				throw new Exception("Table does not exist");
			}
		}
		long endTime = System.currentTimeMillis();
		System.out.println("Time Taken : " + (endTime - startTime) + "ms");

	}

	public void alter() throws IOException, JSONException {
		long startTime = System.currentTimeMillis();
		MetaStore meta = new MetaStore();
		meta.setTable(newTableName);
		if (meta.checkTable()) {
			System.err.println("Table " + newTableName + " exists");
		} else {
			meta.setTable(TableName);
			if (meta.checkTable()) {

				meta.alterEntry(newTableName);
				Configuration config = new Configuration();
				File dir = new File(config.getDBLoc() + "/" + TableName);
				File newDir = new File(config.getDBLoc() + "/" + newTableName);
				dir.renameTo(newDir);
				System.out.println("Table Altered");
			} else {
				System.err.println("Table " + TableName + " does not exist");
			}
		}
		long endTime = System.currentTimeMillis();
		System.out.println("Time Taken : " + (endTime - startTime) + " ms");

	}

	public void setTableName(String tablename) {
		TableName = tablename;
	}

	long StartTime = System.currentTimeMillis();

	public void setColumnFamily(String newColumnFamily) {
		ColumnFamily = newColumnFamily;
	}

	public void setColfamChangeTo(String newColumnFamily) {
		ChangedToColumnFamily = newColumnFamily;
	}

	public void setNewTableName(String tablename) {
		newTableName = tablename;
	}

}
