package org.nosqlite4j.core.dml;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

import org.json.JSONException;
import org.json.JSONObject;
import org.nosqlite4j.core.DBManager;
import org.nosqlite4j.core.MetaStore;

public class Delete extends DBManager {
	private String TableName;
	private String ColumnFamily;
	private String Qualifier;
	private String Key;

	public Delete() {

	}

	public Delete(String tablename, String columnfamily, String qualifier) {
		this.TableName = tablename;
		this.Qualifier = qualifier;
		this.ColumnFamily = columnfamily;
	}

	public Delete(String tablename, String columnfamily, String qualifier,
			String key) {
		this.TableName = tablename;
		this.Qualifier = qualifier;
		this.ColumnFamily = columnfamily;
		this.setKey(key);
	}

	public void delete() throws JSONException, IOException {
		MetaStore meta = new MetaStore();
		long startTime = System.currentTimeMillis();

		if (TableName == null || ColumnFamily == null) {
			System.err.println("Table not specified");
		} else if (Key != null && Qualifier != null) {
			meta.setTable(TableName);
			if (meta.checkTable()) {

				FileInputStream fistream = new FileInputStream(getDBloc() + "/"
						+ TableName + "/" + ColumnFamily + "/" + Qualifier);
				DataInputStream in = new DataInputStream(fistream);
				BufferedReader br = new BufferedReader(
						new InputStreamReader(in));
				FileWriter fstream = new FileWriter(getDBloc() + "/"
						+ TableName + "/" + ColumnFamily + "/" + Qualifier);
				BufferedWriter out = new BufferedWriter(fstream);

				String strLine;
				while ((strLine = br.readLine()) != null) {
					JSONObject obj = new JSONObject(strLine);
					if (obj.has(Key)) {
						obj.remove(Key);
						System.out.println("Key deleted");
					} else {
						out.write(strLine);
					}
				}
				in.close();
				out.close();
			} else {
				System.err.println("Table Does not exist");
			}

		} else if (Key == null && Qualifier != null) {
			meta.setTable(TableName);
			if (meta.checkTable()) {
				File qualifier = new File(getDBloc() + "/" + TableName + "/"
						+ ColumnFamily + "/" + Qualifier);
				qualifier.delete();
				System.out.println("Qualifier deleted");
			} else {
				System.err.println("Table does not exist");
			}
		}
		long endTime = System.currentTimeMillis();
		System.out.println("Time Taken : " + (endTime - startTime) + " ms");

	}

	public String getTableName() {
		return TableName;
	}

	public void setTableName(String tableName) {
		TableName = tableName;
	}

	public String getColumnFamily() {
		return ColumnFamily;
	}

	public void setColumnFamily(String columnFamily) {
		ColumnFamily = columnFamily;
	}

	public String getQualifier() {
		return Qualifier;
	}

	public void setQualifier(String qualifier) {
		Qualifier = qualifier;
	}

	public String getKey() {
		return Key;
	}

	public void setKey(String key) {
		Key = key;
	}

}
