package org.nosqlite4j.core.dml;

import java.io.FileInputStream;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.FileChannel.MapMode;
import java.util.ArrayList;

import org.nosqlite4j.core.DBManager;

public class FreeGet extends DBManager {
	private String Table;
	private String ColumnFamily;
	private String Regex;
	private ArrayList<String> Qualifiers;
	private String Result = "";
	private int Limit;

	public FreeGet(String table, String colfam, String regex) {

		Table = table;
		ColumnFamily = colfam;
		Regex = regex;
		Qualifiers = new ArrayList<String>();

	}

	public FreeGet(String table, String colfam, String regex, int limit) {

		Table = table;
		ColumnFamily = colfam;
		Regex = regex;
		Qualifiers = new ArrayList<String>();
		Limit = limit;

	}

	public void addQualifiers(String qualifier) {
		Qualifiers.add(qualifier);
	}

	public String get() throws IOException {
		long StartTime = System.currentTimeMillis();
		int count = Qualifiers.size();
		int tempLimit = 0;
		while (count > 0) {

			FileInputStream f = new FileInputStream(getDBloc() + "/" + Table
					+ "/" + ColumnFamily + "/" + Qualifiers.get(count - 1));
			FileChannel ch = f.getChannel();
			MappedByteBuffer mb = ch.map(MapMode.READ_ONLY, 0L, ch.size());

			int nGet;
			do {

				nGet = Math.min(mb.remaining(), getReadSize());
				byte[] barray = new byte[nGet];
				mb.get(barray, 0, nGet);
				if (new String(barray).contains(Regex)) {
					String[] splitter = new String(barray).split("\n");
					for (int i = 0; i < splitter.length; i++) {
						if (splitter[i].contains(Regex)) {
							Result = Result + splitter[i] + "\n";
							tempLimit++;
						}
						if (Limit != 0 && tempLimit == Limit) {
							break;
						}

					}
					if (Limit != 0 && tempLimit == Limit) {
						break;
					}

				}
				if (Limit != 0 && tempLimit == Limit) {
					break;
				}

			} while (mb.hasRemaining());
			count--;
		}
		long endTime = System.currentTimeMillis();
		System.out.println("Time taken :" + (endTime - StartTime) + "ms");
		return Result;

	}

	public int getLimit() {
		return Limit;
	}

	public void setLimit(int limit) {
		this.Limit = limit;
	}

}
