package org.nosqlite4j.core.dml;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.FileChannel.MapMode;
import java.util.ArrayList;

import org.json.JSONException;
import org.nosqlite4j.core.DBManager;

public class Get extends DBManager {
	private String Table;
	private String ColumnFamily;
	private String Key;
	private String Result = "";
	private ArrayList<String> Qualifiers = new ArrayList<String>();;

	public Get() {

	}

	public Get(String table, String colfam, ArrayList<String> qualifiers,
			String key) {
		Table = table;
		ColumnFamily = colfam;
		Key = key;
		Qualifiers = new ArrayList<String>();
		Qualifiers = qualifiers;
	}

	public Get(String table, String colfam, ArrayList<String> qualifiers) {
		Table = table;
		ColumnFamily = colfam;
		Qualifiers = qualifiers;
	}

	public Get(String table, String colfam, String key) {

		Table = table;
		ColumnFamily = colfam;
		Key = key;

	}

	public Get(String table, String colfam) {
		Table = table;
		ColumnFamily = colfam;
	}

	public void addQualifiers(String qualifier) {
		Qualifiers.add(qualifier);
	}

	public String get() throws IOException, JSONException, NullPointerException {

		try {
			long StartTime = System.currentTimeMillis();
			String keyvalue = null;
			if (Table == null) {
				System.err.println("Table name not set");
			} else if (ColumnFamily == null) {
				System.err.println("Column family not set");
			} else {
				keyvalue = read(Table);
				if (keyvalue.contains(ColumnFamily)) {

					Fetch(this.getDBloc());

				} else {
					System.err.println("Column family does not exist");
				}
			}
			long endTime = System.currentTimeMillis();
			System.out.println("Time Taken : " + (endTime - StartTime) + " ms");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return Result;

	}

	protected void Fetch(String DBloc) throws IOException, JSONException {
		String found = "";
		if (Key == null && Qualifiers == null) {
			File file = new File(DBloc + "/" + Table + "/" + ColumnFamily + "/");
			read(file);
		} else if (Qualifiers != null && Key == null) {
			int count = Qualifiers.size();
			while (count > 0) {
				FileInputStream fistream = new FileInputStream(DBloc + "/"
						+ Table + "/" + ColumnFamily + "/"
						+ Qualifiers.get(count - 1));
				;
				DataInputStream in = new DataInputStream(fistream);
				BufferedReader br = new BufferedReader(
						new InputStreamReader(in));
				String strLine;
				while ((strLine = br.readLine()) != null) {
					found = found + strLine + "\n";
				}
				in.close();

				count--;
			}
			Result = found;

		}

		else if (Qualifiers != null && Key != null) {
			int count = Qualifiers.size();
			while (count > 0) {

				FileInputStream f = new FileInputStream(getDBloc() + "/"
						+ Table + "/" + ColumnFamily + "/"
						+ Qualifiers.get(count - 1));
				FileChannel ch = f.getChannel();
				MappedByteBuffer mb = ch.map(MapMode.READ_ONLY, 0L, ch.size());

				int nGet;
				do {

					nGet = Math.min(mb.remaining(), getReadSize());
					byte[] barray = new byte[nGet];
					mb.get(barray, 0, nGet);
					if (new String(barray).contains(Key)) {
						String[] splitter = new String(barray).split("\n");
						for (int i = 0; i < splitter.length - 1; i++) {
							if (splitter[i].contains(Key)) {
								String[] newSplit = splitter[i].split("\\"
										+ getDelimiter());
								if (newSplit[0].equals(Key)) {
									Result = Result + splitter[i] + "\n";
								}
							}
						}

					}

				} while (mb.hasRemaining());

				count--;
			}
		}

	}

	protected void read(File file) throws IOException {
		String found = "";
		if (file.isDirectory()) {

			if (file.list().length == 0) {

			} else {
				String files[] = file.list();

				for (String temp : files) {
					File fileDelete = new File(file, temp);
					read(fileDelete);
				}

			}

		} else {
			FileInputStream fistream = new FileInputStream(file);
			DataInputStream in = new DataInputStream(fistream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;
			while ((strLine = br.readLine()) != null) {
				found = found + strLine + "\n";
			}
			Result = found;
			in.close();
		}

	}

	public String getTable() {
		return Table;
	}

	public void setTable(String table) {
		Table = table;
	}

	public String getColumnFamily() {
		return ColumnFamily;
	}

	public void setColumnFamily(String columnFamily) {
		ColumnFamily = columnFamily;
	}

	public String getKey() {
		return Key;
	}

	public void setKey(String key) {
		Key = key;
	}

}
