package org.nosqlite4j.core.dml;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

import org.json.JSONException;
import org.nosqlite4j.core.DBManager;

public class Put extends DBManager {
	private String Table;
	private String ColumnFamily;
	private String Qualifier;
	private String Value;
	private String Key;
	private ArrayList<String> AlternateValues;

	public void setAlternativeValue(ArrayList<String> arr) {
		AlternateValues = arr;
	}

	public Put() {

	}

	public Put(String table, String colfam, String qualifier, String key,
			String value) {
		Table = table;
		ColumnFamily = colfam;
		Qualifier = qualifier;
		Value = value;
		setKey(key);
	}

	public Put(String table, String colfam, String qualifier, String key,
			ArrayList<String> value) {
		Table = table;
		ColumnFamily = colfam;
		Qualifier = qualifier;
		AlternateValues = new ArrayList<String>();
		AlternateValues = value;
		setKey(key);
	}

	public void add() throws IOException, JSONException, NullPointerException {
		try {
			long StartTime = System.currentTimeMillis();
			String keyvalue = null;
			if (Table == null) {
				System.err.println("Table name not set");
			} else if (ColumnFamily == null) {
				System.err.println("Column family not set");
			} else if (Qualifier == null) {
				System.err.println("Qualifier not set");
			} else if ((AlternateValues == null) && (Value == null)) {
				System.err.println("Value not set");
			} else if (AlternateValues != null && AlternateValues.size() > 0) {
				keyvalue = read(Table);
				if (keyvalue.contains(ColumnFamily)) {
					FileOutputStream fos = new FileOutputStream(getDBloc()
							+ "/" + Table + "/" + ColumnFamily + "/"
							+ Qualifier, true);
					byte[] barray = new byte[getReadSize()];
					String value = "";
					for (int i = 0; i < AlternateValues.size(); i++) {
						if (i == 0) {
							value = value + AlternateValues.get(i)
									+ getInternal_Delimiter();
						}

						else if (i == AlternateValues.size() - 1) {
							value = value + AlternateValues.get(i);
						} else {
							value = value + AlternateValues.get(i)
									+ getInternal_Delimiter();
						}
					}
					barray = (Key + getDelimiter() + value + "\n").getBytes();
					fos.write(barray);
					fos.flush();
					fos.close();

				} else {
					System.err.println("Column family does not exist");
				}
			} else {
				keyvalue = read(Table);
				if (keyvalue.contains(ColumnFamily)) {
					FileOutputStream fos = new FileOutputStream(getDBloc()
							+ "/" + Table + "/" + ColumnFamily + "/"
							+ Qualifier, true);
					byte[] barray = new byte[getReadSize()];
					barray = (Key + getDelimiter() + Value + "\n").getBytes();
					fos.write(barray);
					fos.flush();
					fos.close();

				} else {
					System.err.println("Column family does not exist");
				}
			}
			long endTime = System.currentTimeMillis();
			System.out.println("Time Taken : " + (endTime - StartTime) + " ms");
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public String getTable() {
		return Table;
	}

	public void setTable(String table) {
		Table = table;
	}

	public String getColumnFamily() {
		return ColumnFamily;
	}

	public void setColumnFamily(String columnFamily) {
		ColumnFamily = columnFamily;
	}

	public String getQualifier() {
		return Qualifier;
	}

	public void setQualifier(String qualifier) {
		Qualifier = qualifier;
	}

	public String getValue() {
		return Value;
	}

	public void setValue(String value) {
		Value = value;
	}

	public String getKey() {
		return Key;
	}

	public void setKey(String key) {
		Key = key;
	}

}
