package org.nosqlite4j.core.dml;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.FileChannel.MapMode;

import org.json.JSONException;
import org.nosqlite4j.core.DBManager;
import org.nosqlite4j.core.MetaStore;

public class Scan extends DBManager {
	private String Result = "";
	private String Table;
	private int rowcount = 0;
	private int limit;

	public Scan(String tablename) {
		setTable(tablename);
	}

	public String scan() throws IOException, JSONException {
		long StartTime = System.currentTimeMillis();
		File file = new File(getDBloc() + "/" + Table + "/");
		MetaStore meta = new MetaStore();
		meta.setTable(Table);
		if (meta.checkTable()) {
			read(file);

		} else {
			System.err.println("Table does not exist");
		}

		long endTime = System.currentTimeMillis();
		System.out.println("Time Taken : " + (endTime - StartTime) + " ms");
		return Result;

	}

	protected void read(File file) throws IOException {
		String tempFile = "";
		if (file.isDirectory()) {
			if (file.list().length != 0) {
				String files[] = file.list();
				for (String temp : files) {
					File fileDelete = new File(file, temp);
					read(fileDelete);
				}
			}
		} else {

			FileInputStream f = new FileInputStream(file);
			FileChannel ch = f.getChannel();
			MappedByteBuffer mb = ch.map(MapMode.READ_ONLY, 0L, ch.size());
			String strLine = "";
			int nGet;
			while (mb.hasRemaining()) {
				if (limit != 0) {
					if (rowcount < limit) {
						nGet = Math.min(mb.remaining(), getReadSize());
						byte[] barray = new byte[nGet];
						mb.get(barray, 0, nGet);
						String[] splitter = new String(barray).split("\n");
						for (int i = 0; i < splitter.length - 1; i++) {
							if (rowcount < limit) {
								tempFile = file.toString();
								String[] res = tempFile.replaceAll(getDBloc(),
										"").split("/");
								strLine = res[1] + getDelimiter() + res[2]
										+ getDelimiter() + res[3]
										+ getDelimiter() + splitter[i];
								Result = Result + strLine + "\n";
								rowcount++;
							} else {
								break;
							}
						}
					} else {
						break;
					}
				} else {
					nGet = Math.min(mb.remaining(), getReadSize());
					byte[] barray = new byte[nGet];
					mb.get(barray, 0, nGet);

					String[] splitter = new String(barray).split("\n");
					for (int i = 0; i < splitter.length; i++) {
						tempFile = file.toString();
						String[] res = tempFile.replaceAll(getDBloc(), "")
								.split("/");
						strLine = res[1] + getDelimiter() + res[2]
								+ getDelimiter() + res[3] + getDelimiter()
								+ splitter[i];
						Result = Result + strLine + "\n";
						rowcount = rowcount + 1;
						Result = Result + splitter[i] + "\n";

					}
				}
			}
		}
	}

	public int getRowCount() {
		return rowcount;
	}

	public String getTable() {
		return Table;
	}

	public void setTable(String table) {
		Table = table;
	}

	public int getLimit() {
		return limit;
	}

	public void setLimit(int limit) {
		this.limit = limit;
	}

}
