package org.nosqlite4j.core.service;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.jetty.server.Handler;
import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.handler.AbstractHandler;
import org.eclipse.jetty.server.handler.ContextHandler;
import org.eclipse.jetty.server.handler.HandlerList;
import org.json.JSONException;
import org.nosqlite4j.core.dml.FreeGet;
import org.nosqlite4j.core.dml.Get;
import org.nosqlite4j.core.dml.Put;
import org.nosqlite4j.core.dml.Scan;

public class Service {
	private int Port;

	public Service() {

	}

	public Service(int Port) {
		this.Port = Port;
	}

	public void service() throws Exception {
		Server server = new Server(Port);

		ContextHandler contextGet = new ContextHandler();
		ContextHandler contextPut = new ContextHandler();
		ContextHandler contextScan = new ContextHandler();
		ContextHandler contextFreeGet = new ContextHandler();

		contextGet.setContextPath("/get");
		contextPut.setContextPath("/put");
		contextScan.setContextPath("/scan");
		contextFreeGet.setContextPath("/freeget");
		contextGet.setResourceBase(".");
		contextPut.setResourceBase(".");
		contextScan.setResourceBase(".");
		contextGet.setResourceBase(".");
		contextPut.setResourceBase(".");
		contextScan.setResourceBase(".");
		contextFreeGet.setResourceBase(".");

		HandlerList handlers = new HandlerList();
		Handler[] handle = { contextGet, contextPut, contextScan,
				contextFreeGet };

		handlers.setHandlers(handle);
		contextGet.setClassLoader(Thread.currentThread()
				.getContextClassLoader());
		server.setHandler(handlers);

		contextGet.setHandler(new AbstractHandler() {

			@Override
			public void handle(String target, Request baseRequest,
					HttpServletRequest request, HttpServletResponse response)
					throws IOException, ServletException {
				String table = request.getParameter("table");
				String colfam = request.getParameter("cf");
				String qualifier = request.getParameter("q");
				String key = request.getParameter("key");
				response.setContentType("text/html;charset=utf-8");
				response.setStatus(HttpServletResponse.SC_OK);
				baseRequest.setHandled(true);
				Get get = new Get(table, colfam, key);
				get.addQualifiers(qualifier);
				try {
					response.getOutputStream().println(get.get());
				} catch (NullPointerException | JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});

		contextPut.setHandler(new AbstractHandler() {

			@Override
			public void handle(String target, Request baseRequest,
					HttpServletRequest request, HttpServletResponse response)
					throws IOException, ServletException {
				String table = request.getParameter("table");
				String colfam = request.getParameter("cf");
				String qualifier = request.getParameter("q");
				String key = request.getParameter("key");
				String value = request.getParameter("value");
				response.setContentType("text/html;charset=utf-8");
				response.setStatus(HttpServletResponse.SC_OK);
				baseRequest.setHandled(true);
				Put put = new Put(table, colfam, qualifier, key, value);
				try {
					put.add();
				} catch (NullPointerException | JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		contextScan.setHandler(new AbstractHandler() {

			@Override
			public void handle(String target, Request baseRequest,
					HttpServletRequest request, HttpServletResponse response)
					throws IOException, ServletException {
				String table = request.getParameter("table");
				// String colfam = request.getParameter("cf");
				// String qualifier = request.getParameter("q");
				// String key = request.getParameter("key");
				response.setContentType("text/html;charset=utf-8");
				response.setStatus(HttpServletResponse.SC_OK);
				baseRequest.setHandled(true);
				Scan scan = new Scan(table);
				try {
					response.getOutputStream().println(scan.scan());
				} catch (NullPointerException | JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		contextFreeGet.setHandler(new AbstractHandler() {

			@Override
			public void handle(String target, Request baseRequest,
					HttpServletRequest request, HttpServletResponse response)
					throws IOException, ServletException {
				String table = request.getParameter("table");
				String colfam = request.getParameter("cf");
				String qualifier = request.getParameter("q");
				String key = request.getParameter("key");
				int limit = Integer.parseInt(request.getParameter("limit"));
				response.setContentType("text/html;charset=utf-8");
				response.setStatus(HttpServletResponse.SC_OK);
				baseRequest.setHandled(true);
				FreeGet get = new FreeGet(table, colfam, key, limit);
				get.addQualifiers(qualifier);
				try {
					response.getOutputStream().println(get.get());
				} catch (NullPointerException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		server.start();
		server.join();
	}
}